//+-----------------------------------------------------------------------+
//|                                             Heiken ashi MTF sw.mq4    |
//|                                      http://www.metaquotes.net;       |    
//|                                      http://www.forex-tsd.com    ki   |
//+-----------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"



#property indicator_separate_window
#property indicator_buffers 6

#property indicator_color1 OrangeRed //sellbody ult
#property indicator_color2 SteelBlue //buybody ult
#property indicator_color4 Brown     //sellwick
#property indicator_color5 DarkBlue  //buywick
#property indicator_color3 Lavender
#property indicator_color6 Lavender

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1



extern int     TimeFrame   = 0;
extern int     Shift       = 0;
extern int     xShift      = 0;

extern color   WickUpColor = DarkBlue;
extern color   WickDnColor = Brown;
extern color   BodyUpColor = SteelBlue;
extern color   BodyDnColor = OrangeRed;
extern color   BgrColor    = Lavender;

extern int     WickWidth   = 1;
extern int     BodyWidth   = 2; 


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {


   if(TimeFrame==0) TimeFrame = Period();
   
   
   
 //---- indicator line
      
   
   SetIndexBuffer(3,ExtMapBuffer1);
   SetIndexStyle (3,DRAW_HISTOGRAM,0,WickWidth,WickDnColor);
   SetIndexLabel (3,NULL);
   SetIndexShift (3,xShift+Shift*TimeFrame/Period());
   
   SetIndexBuffer(4,ExtMapBuffer2);
   SetIndexStyle (4,DRAW_HISTOGRAM,0,WickWidth,WickUpColor);
   SetIndexLabel (4,NULL);
   SetIndexShift (4,xShift+Shift*TimeFrame/Period());   
     
   SetIndexBuffer(0,ExtMapBuffer3);  
   SetIndexStyle (0,DRAW_HISTOGRAM,0,BodyWidth,BodyDnColor);
   SetIndexLabel (0,NULL);   
   SetIndexShift (0,xShift+Shift*TimeFrame/Period());
      
   SetIndexBuffer(1,ExtMapBuffer4); 
   SetIndexStyle (1,DRAW_HISTOGRAM,0,BodyWidth,BodyUpColor);
   SetIndexLabel (1,NULL);
   SetIndexShift (1,xShift+Shift*TimeFrame/Period()); 
    
   SetIndexBuffer(5,ExtMapBuffer5);
   SetIndexStyle (5,DRAW_HISTOGRAM,0,1,BgrColor);
   SetIndexLabel (5,NULL);
   SetIndexShift (5,xShift+Shift*TimeFrame/Period()); 
   
   SetIndexBuffer(2,ExtMapBuffer6);
   SetIndexStyle (2,DRAW_HISTOGRAM,0,2,BgrColor);
   SetIndexLabel (2,NULL);
   SetIndexShift (2,xShift+Shift*TimeFrame/Period());    
   
  

     
    
    
   
   


   if (TimeFrame <= Period()) TimeFrame = Period();

//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("Heiken ashi MTF sw ["+TimeFrameStr+"]");   
   return(0);
}
//----
   
 
//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,3*TimeFrame/Period()),Bars-1);
   for(int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"Heiken ashi",0,y);
         ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"Heiken ashi",1,y);
         ExtMapBuffer3[i]=iCustom(NULL,TimeFrame,"Heiken ashi",2,y);
         ExtMapBuffer4[i]=iCustom(NULL,TimeFrame,"Heiken ashi",3,y);
            ExtMapBuffer5[i]=MathMin(ExtMapBuffer1[i], ExtMapBuffer2[i]);
 	         ExtMapBuffer6[i]=MathMin(ExtMapBuffer3[i], ExtMapBuffer4[i]); 
   }  
   return(0);
}